"use strict";
// Copyright (c) Rodrigo Speller. All rights reserved.
// Licensed under the Apache License, Version 2.0.
// See License.txt in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
const Entry_1 = require("./Entry");
const DefaultContainer_1 = require("./DefaultContainer");
class ContainerBuilder {
    constructor() {
        this.container = new DefaultContainer_1.default();
    }
    registerInternal(arg1, arg2, lifetime) {
        let tag, factory;
        if (arg1 instanceof Function) {
            tag = Symbol();
            factory = arg1;
        }
        else if (arg2 instanceof Function) {
            tag = arg1;
            factory = arg2;
        }
        else
            throw new TypeError();
        this.container.setEntry(tag, factory, lifetime);
        return this;
    }
    build() {
        return this.container.clone();
    }
    register(arg1, arg2) {
        return this.registerInternal(arg1, arg2, Entry_1.TransientEntry);
    }
    registerSingleton(arg1, arg2) {
        return this.registerInternal(arg1, arg2, Entry_1.SingletonEntry);
    }
    registerScoped(arg1, arg2) {
        return this.registerInternal(arg1, arg2, Entry_1.ScopedEntry);
    }
}
exports.default = ContainerBuilder;
