"use strict";
// Copyright (c) Rodrigo Speller. All rights reserved.
// Licensed under the Apache License, Version 2.0.
// See License.txt in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
const ContainerBase_1 = require("./ContainerBase");
const ScopedContainer_1 = require("./ScopedContainer");
class DefaultContainer extends ContainerBase_1.default {
    createScope() {
        return new ScopedContainer_1.default(this, this.entries.clone());
    }
    setEntry(tag, factory, lifetime) {
        let entry = this.entries.get(tag);
        if (entry != null)
            entry.release(this.containerSymbol);
        entry = this.createEntry(tag, factory, lifetime);
        this.entries.set(tag, entry);
        return entry;
    }
    clone() {
        return new DefaultContainer(this.entries.clone());
    }
}
exports.default = DefaultContainer;
