"use strict";
// Copyright (c) Rodrigo Speller. All rights reserved.
// Licensed under the Apache License, Version 2.0.
// See License.txt in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
class EntryMap {
    constructor() {
        this.bucket = {};
    }
    get(tag) {
        return this.bucket[tag];
    }
    set(tag, entry) {
        this.bucket[tag] = entry;
    }
    forEach(fn) {
        let bucket = this.bucket;
        for (let k of Object.getOwnPropertyNames(bucket))
            fn(k, bucket[k]);
        for (let k of Object.getOwnPropertySymbols(bucket))
            fn(k, bucket[k]);
    }
    clone() {
        let entries = new EntryMap();
        this.forEach((tag, entry) => entries.set(tag, entry.clone()));
        return entries;
    }
}
exports.default = EntryMap;
