"use strict";
// Copyright (c) Rodrigo Speller. All rights reserved.
// Licensed under the Apache License, Version 2.0.
// See License.txt in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
const Entry_1 = require("./Entry");
class ScopedEntry extends Entry_1.default {
    constructor() {
        super(...arguments);
        this.activated = false;
    }
    resolve(activator) {
        if (!this.activated) {
            this.instance = activator.activate(this.factory);
            this.activated = true;
        }
        return this.instance;
    }
    clone() {
        return new ScopedEntry(this.tag, this.factory);
    }
}
exports.default = ScopedEntry;
