"use strict";
// Copyright (c) Rodrigo Speller. All rights reserved.
// Licensed under the Apache License, Version 2.0.
// See License.txt in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
const Entry_1 = require("./Entry");
const ContainerBase_1 = require("./ContainerBase");
class ScopedContainer extends ContainerBase_1.default {
    constructor(parent, entries) {
        super(entries);
        this.parent = parent;
    }
    createScope() {
        return new ScopedContainer(this.parent, this.entries.clone());
    }
    getEntry(arg1) {
        let entry = super.getEntry(arg1);
        if (entry == null || entry instanceof Entry_1.SingletonEntry)
            entry = this.parent.getEntry(arg1);
        return entry;
    }
}
exports.default = ScopedContainer;
