"use strict";
// Copyright (c) Rodrigo Speller. All rights reserved.
// Licensed under the Apache License, Version 2.0.
// See License.txt in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolver = Symbol();
class Container {
}
exports.Container = Container;
function getResolver(type) {
    let typeFactory = type[exports.resolver];
    if (typeFactory != null)
        return typeFactory;
    return (container) => new type(container);
}
exports.getResolver = getResolver;
function isClass(func) {
    return typeof func === 'function'
        && Function.prototype.toString.call(func).substr(0, 5) == 'class';
}
exports.isClass = isClass;
